package CaptiveSupply;
//Social learning

import java.util.*;

import tools.*;

import java.lang.*;

public class Buyer {
 
	Buyer(ModelCS m,int id){
		
		ID=id;
    	ContractNo=new int[m.ParallelMarket];
		ContractRatio=new double[m.ParallelMarket];	
		PreviousContractRatio=new double[m.ParallelMarket];
		PreviousContract=new double[m.ParallelMarket];
		
		ContractQuantity=new double[m.ParallelMarket];
		PreviousContractQuantity=new double[m.ParallelMarket];
		
		CapacityRatio=new double[m.ParallelMarket];			
		Capacity=new double[m.ParallelMarket];
		CapacityCost=new double[m.ParallelMarket];
		
		PreviousCapacityRatio=new double[m.ParallelMarket];
		PreviousCapacity=new double[m.ParallelMarket];		
		
		vector=new double[m.ParallelMarket][5];//0: for price ratio; 1: for capacity ratio;2:contract ratio

		BestLocalParameter=new double[m.ParallelMarket][5];	//[0:profit],[1:price parameter][2:capacity parameter] [3: contract parameter][4:ContractPremium]
		BestGlobalParameter=new double[5];//[0:profit],[1:parameter][2:capacity parameter]

		LocalParameter=new double[m.PSOTestNumber+1][m.ParallelMarket][5];

		Cost=new double[m.ParallelMarket];
		PreviousCost=new double[m.ParallelMarket];
		
	
		WeeklyProfit=new double[m.ParallelMarket][m.WeekPerCycle]; 
		PreviousProfit=new double[m.ParallelMarket];
		profit=new double[m.ParallelMarket];
		
		PreviousSpotQuantity=new double[m.ParallelMarket];
		SpotQuantity=new double[m.ParallelMarket];

		}
	
//algorithm	
	
	
	boolean BrokeUP;
	int[] Converge;//when equal value shows up to 20 time periods, 
	
	int ID;
	
//properties;
	double[] Cost;
	double[] PreviousCost;
	double   cost0,cost1,cost2;
	
//parameter related;
	double[] ContractQuantity;
	double[] PreviousContractQuantity;
	
	double[][]    BestLocalParameter;	//[parallel market]; then storage sequence: [0]profit [1] PriceRatio
	double[]      BestGlobalParameter;	
	double[][][]  LocalParameter;
	

	int[]    ContractNo;
	double[] ContractRatio;
	double[] PreviousContractRatio;
	double[] PreviousContract;
	
	
	double[] profit;
	double[] PreviousProfit;
	double[] ConvergeProfit;

	double[][] vector;
	
	double[] CapacityRatio;
	double[] Capacity;
	double[] CapacityCost;
	double[] PreviousCapacityRatio;
	double[] PreviousCapacity;	
	
	double[] SpotQuantity;	
	double[] PreviousSpotQuantity;
	
	double[][] WeeklyProfit;


//Initializations
	
	void EvolutionInitialization(ModelCS m,EquilibriumCriterion em,PSO PSO,int e,int pm){

		for(int i=0;i<m.WeekPerCycle;i++)WeeklyProfit[pm][i]=0;		
		CapacityRatio(m,PSO,e,pm);	
		ContractRatio(m,PSO,e,pm);
	}

	void WeekInitialization(ModelCS m,MarketInformationCenter MIC,EquilibriumCriterion em,int e,int pm){
		
		Capacity(m,em,e,pm);
		profit[pm]=0;
		
	}	
//	=========functions====================//
	void ContractRatio(ModelCS m,PSO PSO, int e,int pm){
		if(m.FixedContract==true){ContractRatio[pm]=(double)(m.TotalbuyerNumber-1)/(double)(m.TotalbuyerNumber*m.TotalbuyerNumber);
		return;}

		else{
		if(e<0){
		ContractRatio[pm]=0.2*Math.random();LocalParameter[e+m.PSOTestNumber][pm][3]=0.2*Math.random();BestGlobalParameter[3]=0.2*Math.random();
		BestLocalParameter[pm][3]=LocalParameter[e+m.PSOTestNumber][pm][3];
		if(ContractRatio[pm]>CapacityRatio[pm])ContractRatio[pm]=CapacityRatio[pm];	return;}
		
		vector[pm][3]=PSO.w*vector[pm][3]+PSO.c1*m.r.nextDouble()*(BestLocalParameter[pm][3]-PreviousContractRatio[pm])+PSO.c2*m.r.nextDouble()*(BestGlobalParameter[3]-PreviousContractRatio[pm]); 

		ContractRatio[pm]=vector[pm][3]+PreviousContractRatio[pm];
			
		if(ContractRatio[pm]>=1.0/(double)m.TotalbuyerNumber){ContractRatio[pm]=1.0/(double)m.TotalbuyerNumber;}	  
	   
	   if (ContractRatio[pm]<0)ContractRatio[pm]=0;
	   vector[pm][3]=ContractRatio[pm]-PreviousContractRatio[pm];
		}	
		ContractNo[pm]=(int)(ContractRatio[pm]*m.TotalsellerNumber);
	
	}
	
	void Contract(ModelCS m,int pm){
		ContractNo[pm]=(int)(ContractRatio[pm]*m.TotalsellerNumber);
		}
	
	void ContractQuantity(ModelCS m,MarketInformationCenter MIC,int pm){
		ContractNo[pm]=(int)(ContractRatio[pm]*m.TotalsellerNumber);
		if(m.FixedContractQuantity==true)ContractQuantity[pm]=ContractNo[pm]*50;
		else ContractQuantity[pm]=MIC.PreviousAveragePrice[pm]*ContractNo[pm];	
		}
	
	void CapacityRatio(ModelCS m,PSO PSO,int e,int pm){
		
		if(e<0){
		CapacityRatio[pm]=.1+0.5*Math.random(); 
		LocalParameter[e+m.PSOTestNumber][pm][2]=.1+0.3*Math.random();BestGlobalParameter[2]=.1+0.3*Math.random();
		BestLocalParameter[pm][2]=LocalParameter[e+m.PSOTestNumber][pm][2];
		return;}
			
		vector[pm][2]=PSO.w*vector[pm][2]+PSO.c1*m.r.nextDouble()*(BestLocalParameter[pm][2]-PreviousCapacityRatio[pm])+PSO.c2*m.r.nextDouble()*(BestGlobalParameter[2]-PreviousCapacityRatio[pm]); 

		CapacityRatio[pm]=vector[pm][2]+PreviousCapacityRatio[pm];

	   if(CapacityRatio[pm]>1&& e<250)CapacityRatio[pm]=Math.random();
	   else if(CapacityRatio[pm]>1){CapacityRatio[pm]=1;}
	   
	   else if(CapacityRatio[pm]<0&& e<250)CapacityRatio[pm]=.1*Math.random();   
	   else if (CapacityRatio[pm]<0) CapacityRatio[pm]=0;	   
	   
	   vector[pm][2]=CapacityRatio[pm]-PreviousCapacityRatio[pm];
	}
	void Capacity(ModelCS m,EquilibriumCriterion em,int e,int pm){	Capacity[pm]=m.BuyerCapacity*CapacityRatio[pm];	}

	void WeeklyProfit(ModelCS m,SpotMarket dm,MarketInformationCenter MIC,int week,int pm){		
		this.ContractQuantity(m, MIC, pm);
		WeeklyProfit[pm][week]=(m.RetailPrice-MIC.PreviousAveragePrice[pm])*(this.ContractQuantity[pm]+Capacity[pm]);//processing cost=0;
	}
	
	void StorageParameter(ModelCS m,int pm){
		double profitC=0;int week;		
		double count=0;
	    if(m.WeekPerCycle>=3)week=2;else week=0;
		
		for(int i=week;i<m.WeekPerCycle;i++){
		profitC+=WeeklyProfit[pm][i];count++;}		
		profitC=profitC/count;
		profit[pm]=profitC;		
	}
	
	void StoragePrevious(ModelCS m,int pm){

		 PreviousCapacityRatio[pm]= CapacityRatio[pm];	
		 PreviousContractRatio[pm]= ContractRatio[pm];	
		
		 PreviousContractQuantity[pm]=ContractQuantity[pm];
		 PreviousCapacity[pm]= Capacity[pm];
    	 PreviousProfit[pm]=profit[pm];
	}
	

	void printbuyer(int i){
		if(i==0)Print.t("\t=======================================buyer "+i+"=============================================");
		else    Print.t("\t=======================================buyer "+i+"=============================================");
	};	
	
	void printPR(int i){		
		if(i==0){Print.t("\t|"+i+"CaR\tCnR"); Print.t("profit");}
		else {Print.t("\t|"+i+"CaR\tCnR "); Print.t("profit");}
	}
	

	void printPriceRatio(ModelCS m,int pm,int e){		
		System.out.print("  #");
		Print.t4(PreviousCapacityRatio[pm]);
		Print.t4(PreviousContractRatio[pm]);
		Print.te(PreviousProfit[pm]);Print.t(" ");
	}	
	
}//:;


