package CaptiveSupply;
import java.util.*;
import tools.Print;
public class EquilibriumCriterion {
	int CriterionNo=40;
	double JudgeDevPR[]={0.0005,0.0001};//sum deviation of 20 iteration;	
	double JudgeDevCR[]={0.0001,0.0001};
	
	boolean  JudgeEquilibrium;
	
	double[]   AverageMarketPrice;
	
	double[][]   ContractRatio;
	double[][]   CapacityRatio;
	double[][]   capacity;
	double[][]   q;
	double[][]   profit;
	double     convergeTime;
	
	double[][][][] JudgeParameter;

	double[]   AverageMarketPriceTemp;
	double[][] ContractRatioTemp;
	double[][] CapacityRatioTemp;
	double[][] capacityTemp;
	double[][] qTemp;
	double[][] profitTemp;
	
	EquilibriumCriterion(ModelCS m,int parameterNo){
		parameterNo=parameterNo;
		
		AverageMarketPrice=new double[2];
		ContractRatio   =new double[m.TotalbuyerNumber][2];//use [0] storage average value;[1]deviation
		CapacityRatio=new double[m.TotalbuyerNumber][2];
		

		capacity     =new double[m.TotalbuyerNumber][2];
		q            =new double[m.TotalbuyerNumber][2];
		profit       =new double[m.TotalbuyerNumber][2];	
		
		JudgeParameter=new double[m.TotalbuyerNumber][2][CriterionNo/10][2];//Judge equilibrium of series of time periods;
		
		AverageMarketPriceTemp=new double[CriterionNo];
		ContractRatioTemp   =new double[m.TotalbuyerNumber][CriterionNo]; 
		CapacityRatioTemp=new double[m.TotalbuyerNumber][CriterionNo]; 
		capacityTemp     =new double[m.TotalbuyerNumber][CriterionNo]; 
		qTemp            =new double[m.TotalbuyerNumber][CriterionNo]; 
		profitTemp       =new double[m.TotalbuyerNumber][CriterionNo]; 		
		
		//use mean value to determine the criteria	                                          
	}
	
	void EquilibriumInitial(){
		convergeTime=0;JudgeEquilibrium=false;
		}
	
	void EquilibriumStorageParameter(Buyer[] b,ModelCS m,SpotMarket dm,int e,int parameterNo){
		if(e<CriterionNo&&e>0){
			AverageMarketPriceTemp[e]=dm.PreviousAveragePrice[0];
			for(int i=0;i<b.length;i++)
			{
			ContractRatioTemp[i][e]=b[i].PreviousContractRatio[0];
			CapacityRatioTemp[i][e]=b[i].PreviousCapacityRatio[0];
			capacityTemp[i][e]=b[i].PreviousCapacity[0];
			qTemp[i][e]=b[i].PreviousSpotQuantity[0];
			profitTemp[i][e]=b[i].PreviousProfit[0];	
			}

		}
		else{

			for(int k=0;k<CriterionNo-1;k++){AverageMarketPriceTemp[k]=AverageMarketPriceTemp[k+1];}
			
			AverageMarketPriceTemp[CriterionNo-1]=dm.PreviousAveragePrice[0];
			
			for(int i=0;i<b.length;i++){
				for(int k=0;k<CriterionNo-1;k++){
				
				ContractRatioTemp[i][k]=ContractRatioTemp[i][k+1];
				CapacityRatioTemp[i][k]=CapacityRatioTemp[i][k+1];
				capacityTemp[i][k]=capacityTemp[i][k+1];
				qTemp[i][k]=qTemp[i][k+1];
				profitTemp[i][k]=profitTemp[i][k+1];
			}	
			ContractRatioTemp[i][CriterionNo-1]=b[i].PreviousContractRatio[0];
			CapacityRatioTemp[i][CriterionNo-1]=b[i].PreviousCapacityRatio[0];

			capacityTemp[i][CriterionNo-1]=b[i].PreviousCapacity[0];
			qTemp[i][CriterionNo-1]=b[i].PreviousSpotQuantity[0];
			profitTemp[i][CriterionNo-1]=b[i].PreviousProfit[0];
			}

		} 
			
	}
	
	void TestEquilibrium(Buyer[] b,ModelCS m,int e,int parameterNo){
		double mean[]=new double[2];
		double std[]=new double[2];
		double pr[]=new double[CriterionNo/10]; 
		double cr[]=new double[CriterionNo/10];
		double s[]=new double[2];
		boolean EorNot=false;
		
		for(int i=0;i<b.length;i++){
			
			for(int k=0;k<CriterionNo/10;k++){
				
			System.arraycopy(ContractRatioTemp[i], k*10,pr, 0, pr.length);
			MeanDeviation(pr,s,e,-1);
			JudgeParameter[i][0][k][0]=s[0];	JudgeParameter[i][0][k][1]=s[1];
			
			if(parameterNo>1){
			System.arraycopy(CapacityRatioTemp[i], k*10,cr, 0, cr.length);		
			MeanDeviation(cr,s,e,-1);
			
			JudgeParameter[i][1][k][0]=s[0];	
			JudgeParameter[i][1][k][1]=s[1];				
			}
			}
			
		}
		
		
			
		JudgeEquilibrium=false;
		
		// price ratio convergence;
		Arrays.fill(mean,0);Arrays.fill(std,0);
		
		for(int i=0;i<b.length;i++){
		Arrays.fill(mean,0);Arrays.fill(std,0);
		
		for(int k=0;k<CriterionNo/10;k++){	mean[0]+=JudgeParameter[i][0][k][0];	std[0]+=JudgeParameter[i][0][k][1];	}
		mean[0]=mean[0]/(CriterionNo/10);std[0]=std[0]/(CriterionNo/10);
		
		for(int k=0;k<CriterionNo/10;k++){
		mean[1]+=(JudgeParameter[i][0][k][0]-mean[0])*(JudgeParameter[i][0][k][0]-mean[0]);		
		std[1]+=(JudgeParameter[i][0][k][1]-std[0])*(JudgeParameter[i][0][k][1]-std[0]);}
		
		mean[1]=Math.sqrt(Math.abs(mean[1]/(CriterionNo/10-1)));

		
		std[1]=Math.sqrt(Math.abs(std[1]/(CriterionNo/10-1)));
		
		if(mean[1]<JudgeDevPR[0]&&std[1]<JudgeDevPR[1])EorNot=true;else EorNot=false;
		
		if(i==0)JudgeEquilibrium=EorNot;
		else JudgeEquilibrium=JudgeEquilibrium&&EorNot;
		
		if(JudgeEquilibrium==false)return;		
		}
		
		
		
		//capacity ratio convergence;
		if(parameterNo>1){
       
		
		for(int i=0;i<b.length;i++){
		Arrays.fill(mean,0);Arrays.fill(std,0);
		
		for(int k=0;k<CriterionNo/10;k++){	mean[0]+=JudgeParameter[i][1][k][0];	std[0]+=JudgeParameter[i][1][k][1];	}
		mean[0]=mean[0]/(CriterionNo/10);std[0]=std[0]/(CriterionNo/10);
		
		for(int k=0;k<CriterionNo/10;k++){
		mean[1]+=(JudgeParameter[i][1][k][0]-mean[0])*(JudgeParameter[i][1][k][0]-mean[0]);		
		std[1]+=(JudgeParameter[i][1][k][1]-std[0])*(JudgeParameter[i][1][k][1]-std[0]);}
		
		mean[1]=Math.sqrt(mean[1]/(CriterionNo/10-1));
		std[1]=Math.sqrt(std[1]/(CriterionNo/10-1));
		
		if(mean[1]<JudgeDevCR[0]&&std[1]<JudgeDevCR[1])EorNot=true;else EorNot=false;
		
		JudgeEquilibrium=JudgeEquilibrium&&EorNot;
		
		if(JudgeEquilibrium==false)return;		
		}
		}
	}
	
	void Storage(Buyer[] b,int e){	

		int l=10;
		MeanDeviation(AverageMarketPriceTemp,AverageMarketPrice,e,l);
		for(int i=0;i<b.length;i++){	
			MeanDeviation(ContractRatioTemp[i],ContractRatio[i],e,l);
			MeanDeviation(CapacityRatioTemp[i],CapacityRatio[i],e,l);
			MeanDeviation(capacityTemp[i],capacity[i],e,l);
			MeanDeviation(qTemp[i],q[i],e,l);
			MeanDeviation(profitTemp[i],profit[i],e,l);			
		}			
		}
	
	void MeanDeviation(double[] d,double[] s,int e,int l){
		if(e<d.length)return;
		
		double temp=0,temp1=0;
		if(l<0)l=d.length;
		
		for(int k=d.length-l;k<d.length;k++){//P.t("\n"+temp+"\t"+d[k]);
		temp+=d[k];}
		
		temp=temp/l;
		s[0]=temp;//storage parameter mean
		for(int k=d.length-l;k<d.length;k++)temp1+=(temp-d[k])*(temp-d[k]);		
		s[1]=Math.abs(Math.sqrt(temp1/(l-1)));//storage parameter deviation; std=Math.sqrt(temp1/(d.length-1));	
	}

	
	void print0(ModelCS m,int parameterNo){
		Print.t();
		for(int i=0;i<m.TotalbuyerNumber;i++){
			Print.t("PR"+i+"\tPRDev");
			Print.t("CR\t CRDev"); 
			Print.t("bid\t bidDe\t q\t qDev\t profit\t profDev\t");
			
		}
		Print.ln("time");
	}
	void print(ModelCS m,int parameterNo){
		Print.ln();
		
		for(int i=0;i<m.TotalbuyerNumber;i++){			
			Print.t4(ContractRatio[i][0]);Print.t4(ContractRatio[i][1]);
			Print.t4(CapacityRatio[i][0]);Print.t4(CapacityRatio[i][1]);
			Print.te(q[i][0]);Print.te(q[i][1]);
			Print.te(profit[i][0]);Print.te(profit[i][1]);
			Print.t();Print.t();
		}
	
		Print.te(convergeTime);	
	}
}


