package CaptiveSupply;

import java.util.*;
import tools.Print;


public class PSO {
	double w=0.98,c1=2,c2=2;
	void UpdatePSOParameter(ModelCS m, int e){
		if(e<0)e+=m.PSOTestNumber;
		w=0.4+(double)(m.Evolution-e)/(double)(2*m.Evolution);
		c1=1+(double)(m.Evolution-e)/(double)m.Evolution;	//local
		c2=c1;//c1;//global
		double temp=0;
		c1=c1*(1-temp); c2=c2*(1+temp);		
	}
	
	void TestParameterTrade(Buyer buyer,Buyer[] b, Seller[] s,ModelCS m,ContractMarket cm,SpotMarket dm,MarketInformationCenter MIC,EquilibriumCriterion em,PSO PSO,int e){
				int begin,count=0;
				double LocalList[][][]=new double[m.PSOTestNumber+1][m.ParallelMarket][5];//[0:parameter][1:capacity parameter]
				
				//initial
				for(int pm=0;pm<m.ParallelMarket;pm++){
					buyer.BestLocalParameter[pm][0]=-2000000000;
					for(count=0;count<m.PSOTestNumber+1;count++){

						LocalList[count][pm][2]=-1;		//capacity
						if(m.FixedContract==false)LocalList[count][pm][3]=-1;		//contract
		
					}
				}	
				//end initial
				for(int pm=0;pm<m.ParallelMarket;pm++){
					
					count=0;
					for(int ev=0;ev<m.PSOTestNumber;ev++){
					boolean same=false;	
					
					for(int kk=0;kk<count;kk++){
						if(buyer.LocalParameter[ev][pm][2]==LocalList[kk][pm][2]&&buyer.LocalParameter[ev][pm][3]==LocalList[kk][pm][3]){same=true;break;}												
					}
					if (same==false)
					{
						LocalList[count][pm][2]=buyer.LocalParameter[ev][pm][2];
						if(m.FixedContract==false)LocalList[count][pm][3]=buyer.LocalParameter[ev][pm][3];
    					count++;
						}
					}	

					LocalList[count][pm][2]=buyer.PreviousCapacityRatio[pm];
					if(m.FixedContract==false)LocalList[count][pm][3]=buyer.PreviousContractRatio[pm];

					count++;
			}	
				
				for(int pm=0;pm<m.ParallelMarket;pm++){
	
					count=0;
					
					while(LocalList[count][pm][2]>=0) {	
						
						LocalList[count][pm][0]=0;

						buyer.CapacityRatio[pm]=LocalList[count][pm][2];buyer.Capacity(m, em, e, pm);
						if(m.FixedContract==false){buyer.ContractRatio[pm]=LocalList[count][pm][3];	buyer.Contract(m, pm);buyer.ContractQuantity(m, MIC, pm);}					
			
						for(int i=0;i<b.length;i++){	
								if(b[i].ID!=buyer.ID){				
								b[i].CapacityRatio[pm]=b[i].PreviousCapacityRatio[pm]; b[i].Capacity(m, em,e,pm);
								if(m.FixedContract==false){b[i].ContractRatio[pm]=b[i].PreviousContractRatio[pm]; b[i].Contract(m, pm);b[i].ContractQuantity(m, MIC, pm);}
								}
								}//hold other packer's strategies unchanged;

						for(int week=0;week<m.WeekPerCycle;week++){								
							for(int i=0;i<b.length;i++)b[i].WeekInitialization(m,MIC,em,e,pm);
					        cm.MakeADeal(b, s, m, MIC, week, pm);					
							dm.MakeADeal(b,s, m, MIC, week,pm,e);
							
						 buyer.ContractQuantity(m, MIC, pm);					      
						 buyer.WeeklyProfit(m, dm, MIC, week, pm);
						
						}//end weeks;
					
						buyer.StorageParameter(m,pm);
						
						LocalList[count][pm][0]=buyer.profit[pm];//?+										
						
						if((LocalList[count][pm][0]-buyer.BestLocalParameter[pm][0])>=0){
							if(m.FixedContract==false)buyer.BestLocalParameter[pm][3]=buyer.ContractRatio[pm];
							buyer.BestLocalParameter[pm][2]=buyer.CapacityRatio[pm];
							buyer.BestLocalParameter[pm][0]=LocalList[count][pm][0];	
						}
						count++;
						if(count>=m.PSOTestNumber)break;
						}
					
					//storage best local parameter; keep 10 past best local parameter
					for(int i=0;i<m.PSOTestNumber;i++){
						buyer.LocalParameter[i][pm][2]=buyer.LocalParameter[i+1][pm][2];
						if(m.FixedContract==false)buyer.LocalParameter[i][pm][3]=buyer.LocalParameter[i+1][pm][3];
					}	
					buyer.LocalParameter[m.PSOTestNumber][pm][2]=buyer.BestLocalParameter[pm][2];
					if(m.FixedContract==false)buyer.LocalParameter[m.PSOTestNumber][pm][3]=buyer.BestLocalParameter[pm][3];
				}//end pm;
					TestGlobalParameterTrade(buyer,b,s,m,dm,MIC,PSO,e);
				
			}


void TestGlobalParameterTrade(Buyer buyer,Buyer[] b, Seller[] s,ModelCS m, SpotMarket dm,MarketInformationCenter MIC,PSO PSO,int e){
	buyer.BestGlobalParameter[0]=-2000000;
    for(int pm=0;pm<m.ParallelMarket;pm++){
    	if(buyer.BestLocalParameter[pm][0]>buyer.BestGlobalParameter[0]){
    		buyer.BestGlobalParameter[0]=buyer.BestLocalParameter[pm][0];
    		buyer.BestGlobalParameter[2]=buyer.BestLocalParameter[pm][2];
    		if(m.FixedContract==false)buyer.BestGlobalParameter[3]=buyer.BestLocalParameter[pm][3];
    	}
    	
    } 
}


}


